searchNodes=[{"ref":"ExFlux.Application.html","title":"ExFlux.Application","type":"module","doc":"ExFlux&#39;s per-node registry within the library&#39;s exported application ExFlux uses Registry to support database-name-based dispatch as a primary design goal was multi-tenancy or sharding support for non-enterprise use cases."},{"ref":"ExFlux.Application.html#start/2","title":"ExFlux.Application.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"ExFlux.Conn.HTTP.html","title":"ExFlux.Conn.HTTP","type":"module","doc":"DSL around HTTPoison for interacting with the endpoints exposed by InfluxDB"},{"ref":"ExFlux.Conn.HTTP.html#ping/1","title":"ExFlux.Conn.HTTP.ping/1","type":"function","doc":"check the status of the influxdb instance"},{"ref":"ExFlux.Conn.HTTP.html#post_query/2","title":"ExFlux.Conn.HTTP.post_query/2","type":"function","doc":"queries that mutate the database or insert data (i.e. select...into, alter, create, etc)"},{"ref":"ExFlux.Conn.HTTP.html#query/2","title":"ExFlux.Conn.HTTP.query/2","type":"function","doc":"queries that do not mutate the data (i.e. select and show). &quot;select ... into&quot; queries do mutations, so post_query/2 should be used in this case"},{"ref":"ExFlux.Conn.HTTP.html#write/2","title":"ExFlux.Conn.HTTP.write/2","type":"function","doc":"ship datapoints to a pre-existing database when UDP is unreliable or unacceptable"},{"ref":"ExFlux.Conn.UDP.html","title":"ExFlux.Conn.UDP","type":"module","doc":"Light, opinionated wrapper around :gen_udp"},{"ref":"ExFlux.Conn.UDP.html#close/1","title":"ExFlux.Conn.UDP.close/1","type":"function","doc":"when possible, sockets should be closed as a well-behaved program"},{"ref":"ExFlux.Conn.UDP.html#open/2","title":"ExFlux.Conn.UDP.open/2","type":"function","doc":"open a port for UDP with all of the configuration afforded to you by :gen_udp.open/2"},{"ref":"ExFlux.Conn.UDP.html#write/4","title":"ExFlux.Conn.UDP.write/4","type":"function","doc":"convert the string to utf-8 binary and send via udp"},{"ref":"ExFlux.Database.html","title":"ExFlux.Database","type":"behaviour","doc":"Configuration of a single database&#39;s connection pool, queue and supervision tree. Since InfluxDB uses a single server UDP port per database, this library&#39;s goal is to make it easy to do 1:1 mappings of a pool of UDP connections to that destination&#39;s port and batching datapoints. To get started, create your own module and do something like: use ExFlux.Database, otp_app: :your_app, database: &quot;your_db_name&quot; In your application, simply add YourApp.YourExFluxDatabase to the children: children = [ ..., YourApp.YourExFluxDatabase ] The database name isn&#39;t used for the UDP connection in anyway, but it is used to create database-specific workers. To support querying interfaces and HTTP based sending, the database would need to be known. To support these features in the future, the database name is held by all workers in their configuration. Where possible, ExFlux.Database.Supervisor provides sane defaults for configuration options to make it as close as working out of the box as possible. A full list of configuration options and their types can be found there."},{"ref":"ExFlux.Database.html#c:ping/0","title":"ExFlux.Database.ping/0","type":"callback","doc":"GET query against the /ping endpoint in order to get the status of the influxdb instance. If the server is alive, we expect a 204 response and will return :ok or an {:error, reason} tuple otherwise"},{"ref":"ExFlux.Database.html#c:post/1","title":"ExFlux.Database.post/1","type":"callback","doc":"POST to the /query for the configured database. This is used for queries that mutate the database. See ExFlux.Conn.HTTP.post_query/2 for more details"},{"ref":"ExFlux.Database.html#c:push/1","title":"ExFlux.Database.push/1","type":"callback","doc":"queue a single data point (may trigger a batch being sent asynchronously)"},{"ref":"ExFlux.Database.html#c:query/1","title":"ExFlux.Database.query/1","type":"callback","doc":"using the dataabase&#39;s http configuration, query the influx database"},{"ref":"ExFlux.Database.HTTPWorker.html","title":"ExFlux.Database.HTTPWorker","type":"module","doc":"Provides a wrapper around the :hackney pool used for querying/writing on behalf of a paritcular database."},{"ref":"ExFlux.Database.HTTPWorker.html#child_spec/1","title":"ExFlux.Database.HTTPWorker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExFlux.Database.HTTPWorker.html#init/1","title":"ExFlux.Database.HTTPWorker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"ExFlux.Database.HTTPWorker.html#ping/1","title":"ExFlux.Database.HTTPWorker.ping/1","type":"function","doc":"Use the database specific info to ping the target influx server"},{"ref":"ExFlux.Database.HTTPWorker.html#post/2","title":"ExFlux.Database.HTTPWorker.post/2","type":"function","doc":"Use the :post HTTP request method to send the query string to the provided database."},{"ref":"ExFlux.Database.HTTPWorker.html#query/2","title":"ExFlux.Database.HTTPWorker.query/2","type":"function","doc":"Using the database specific configuration, execute the query"},{"ref":"ExFlux.Database.HTTPWorker.html#write/2","title":"ExFlux.Database.HTTPWorker.write/2","type":"function","doc":"Use HTTP request/response semantics to ship metrics to the specific influx database. This is especially useful when UDP is not a viable option."},{"ref":"ExFlux.Database.PoolWorker.html","title":"ExFlux.Database.PoolWorker","type":"module","doc":"A single worker responsible for sending stats to the configured database"},{"ref":"ExFlux.Database.PoolWorker.html#child_spec/1","title":"ExFlux.Database.PoolWorker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExFlux.Database.PoolWorker.html#init/1","title":"ExFlux.Database.PoolWorker.init/1","type":"function","doc":"single pool worker initialization with deferred UDP socket setup"},{"ref":"ExFlux.Database.PoolWorker.html#send_points/2","title":"ExFlux.Database.PoolWorker.send_points/2","type":"function","doc":"Given an identified worker via worker_pid/1 and points, asynchronously ship the points to influx."},{"ref":"ExFlux.Database.PoolWorker.html#worker_pid/1","title":"ExFlux.Database.PoolWorker.worker_pid/1","type":"function","doc":"Perform a non-blocking checkout of an available worker for sending data. If no worker is available, :poolboy.checkout/2 will return :full"},{"ref":"ExFlux.Database.QueueWorker.html","title":"ExFlux.Database.QueueWorker","type":"module","doc":"Async queueing of ExFlux.Points and load shedding per database Batching must be done per-database. To support this effectively, a single worker for each database receives datapoints from your service. If the queue is sufficiently full, it will command one of its pool workers to send a portion of your stats using the configured connection (UDP or HTTP). The queue is implemented via Erlang&#39;s :queue and the size is tracked alongside the queue to reduce the frequency of calculating the length."},{"ref":"ExFlux.Database.QueueWorker.html#child_spec/1","title":"ExFlux.Database.QueueWorker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExFlux.Database.QueueWorker.html#init/1","title":"ExFlux.Database.QueueWorker.init/1","type":"function","doc":"Schedule a the initial flush of queued data points, create the :queue, and initialize the size which is tracked manually to avoid calculating the length of the queue via :queue.len/1"},{"ref":"ExFlux.Database.Supervisor.html","title":"ExFlux.Database.Supervisor","type":"module","doc":"Orchestration and supervision of ex_influx database components The two components of an ex_influx database process: a &quot;sliding buffer&quot; queue, ExFlux.Database.QueueWorker, and a pool of connections to the influxdb server, ExFlux.Database.PoolWorker. Common options for the queue, pool and/or the query interface: :database - the name of the database :host - hostname of the influxdb server The options required by the queue are: :batch_size - an upper limit on the number of points to send at once :max_queue_size - a limit to the number of points to attempt to hold if the data cannot be shipped to influxdb fast enough :flush_interval - a time interval in seconds used to help drain the queue The options required by the pool are: :pool_size - the number of connections/workers to maintain (via :poolboy) :pool_overflow - if set to a number &gt; 0, this allows poolboy to create extra workers when the demand for workers exceeds the supply :upd_conn_opts - a list of one or more UDP connection options required by :gen_udp, defaults to [:binary, {:active, false}] since we are exclusively writing :udp_port - the port number influxdb is listening on for this particular database The options required by the http interface: :http_port - the port number for the query interface (defaults to 8086) :json_encoder - encoder/decoder to use for responses, defaults to Poison :http_opts - extra options passed to HTTPoison see HTTPoison.request/5 for more details (defaults to [timeout: 5000])"},{"ref":"ExFlux.Database.Supervisor.html#child_spec/1","title":"ExFlux.Database.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExFlux.Database.Supervisor.html#init/1","title":"ExFlux.Database.Supervisor.init/1","type":"function","doc":"Callback invoked to start the supervisor and during hot code upgrades. Developers typically invoke Supervisor.init/2 at the end of their init callback to return the proper supervision flags. Callback implementation for Supervisor.init/1."},{"ref":"ExFlux.Database.Supervisor.html#process_env/2","title":"ExFlux.Database.Supervisor.process_env/2","type":"function","doc":"Merge the config and defaults to create a single cohesive configuration map to be used by the pool worker, poolboy, and the queue worker."},{"ref":"ExFlux.Database.Supervisor.html#start_link/3","title":"ExFlux.Database.Supervisor.start_link/3","type":"function","doc":""},{"ref":"ExFlux.Database.Supervisor.html#via_tuple/1","title":"ExFlux.Database.Supervisor.via_tuple/1","type":"function","doc":""},{"ref":"ExFlux.FieldError.html","title":"ExFlux.FieldError","type":"exception","doc":"Raised when no fields were specified on the provided data point"},{"ref":"ExFlux.LineProtocol.html","title":"ExFlux.LineProtocol","type":"module","doc":"Complete implementation of the InfluxDB line protocol Create stats in the line protocol format from ExFlux.Points. The format is name,tag1=tval1,...,tagN=tvalN field1=val1,...,fieldN=valN timestamp where tags and timestamp are optional. There must be at least one field. If the timestamp is not specified, influx will use its own server&#39;s time of receipt as the timestamp. ExFlux.Point in its typespecs defines the line protocols type system. There are additional rules for escaping characters that may or may not be present in a key or value depending on whether it is a measurement name, a tag key or value, or a field key or value. Performance and Setup Tips from the influx docs: Sort tags by key Use the coarsest precision possible (configured elsewhere) Use NTP to synchronize time between hosts (out of scope for this library)"},{"ref":"ExFlux.LineProtocol.html#encode/1","title":"ExFlux.LineProtocol.encode/1","type":"function","doc":"takes maps of well defined points and turns them into single line strings"},{"ref":"ExFlux.Point.html","title":"ExFlux.Point","type":"module","doc":"Data points as Elixir structs For simplicity, timestamps are only dealt with in the unix format within the library. Additionally, both in the typespecs and in the ExFlux.LineProtocol implementation, strings and atoms can be used interchangably in places where the influx line protocol specification calls for strings."},{"ref":"ExFlux.Point.html#t:field_map/0","title":"ExFlux.Point.field_map/0","type":"type","doc":""},{"ref":"ExFlux.Point.html#t:field_value/0","title":"ExFlux.Point.field_value/0","type":"type","doc":""},{"ref":"ExFlux.Point.html#t:influx_string/0","title":"ExFlux.Point.influx_string/0","type":"type","doc":""},{"ref":"ExFlux.Point.html#t:t/0","title":"ExFlux.Point.t/0","type":"type","doc":""},{"ref":"ExFlux.Point.html#t:tag_map/0","title":"ExFlux.Point.tag_map/0","type":"type","doc":""},{"ref":"ExFlux.Point.html#t:tag_value/0","title":"ExFlux.Point.tag_value/0","type":"type","doc":""},{"ref":"ExFlux.Point.html#t:timestamp/0","title":"ExFlux.Point.timestamp/0","type":"type","doc":""},{"ref":"readme.html","title":"ExFlux","type":"extras","doc":"ExFlux An InfluxDB driver that is designed from the ground up to bend, not break under load. In order to accomplish this there were three major design goals: Effectively utilize the InfluxDB UDP protocol by making batched writes a part of the library. Support the complete Influx line protocol with proper escaping and type support Handle load accountably and shed load in a defined FIFO manner when stats cannot be shipped fast enough: prioritize casts over calls drop datapoints from the queue, oldest first, when the queue is full and all UDP socket workers are busy."},{"ref":"readme.html#status","title":"ExFlux - Status","type":"extras","doc":"Full documentation can be found on hexdocs"},{"ref":"readme.html#installation","title":"ExFlux - Installation","type":"extras","doc":"Now available in Hex, the package can be installed by adding ex_flux to your list of dependencies in mix.exs: def deps do [ {:ex_flux, &quot;~&gt; 0.1.0&quot;} ] end"},{"ref":"readme.html#example","title":"ExFlux - Example","type":"extras","doc":"As explained in the Influx UDP protocol, InfluxDB specifies that a UDP port maps to exactly one configured database. Example configuration for InfluxDB .conf files can be found at the bottom of the Influx udp protocol page Create an ExFlux.Database in your project: defmodule YourApp.YourInfluxDatabase do use ExFlux.Database, otp_app: :your_app, database: &quot;database_name&quot; end Add it to your application.ex: children = [ ..., YourApp.YourInfluxDatabase ] To add points in a series, use ExFlux.Points or regular elixir maps interchangeably. A helper for defining series schema is a Near Term TODO. iex(1)&gt; point = %{measurement: &quot;series_name&quot;, fields: %{value: 1}, tags: %{}, timestamp: System.os_time(:nanosecond)} iex(2)&gt; YourApp.SpecificDatabase.push(point) The point will be queued asynchronously and either flushed or sent as part of a batch."},{"ref":"readme.html#near-term-todos","title":"ExFlux - Near Term TODOs","type":"extras","doc":"series specification timestamp granularity support query interface test for load shedding"},{"ref":"readme.html#license","title":"ExFlux - License","type":"extras","doc":"Copyright 2018 Pylon, Inc. Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License."}]